/**
 * Copyright (c) Meta Platforms, Inc. and its affiliates. All Rights Reserved.
 */

'use strict';

var readline = require('readline');

module.exports = function (wit, handleMessage, context) {
  var rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout
  });
  rl.setPrompt('> ');
  var prompt = function prompt() {
    rl.prompt();
    rl.write(null, { ctrl: true, name: 'e' });
  };
  prompt();
  rl.on('line', function (line) {
    line = line.trim();
    if (!line) {
      return prompt();
    }
    wit.message(line, context).then(function (rsp) {
      if (handleMessage) {
        handleMessage(rsp);
      } else {
        console.log(JSON.stringify(rsp));
      }
      prompt();
    }).catch(function (err) {
      return console.error(err);
    });
  });
};